Install from binaries, including renaming of installer, host install and install scripts for RO, SO and UI

Change-Id: Id6e9a134df1fb55969183d2cdf0efd49b1d34e10
Signed-off-by: garciadeblas <gerardo.garciadeblas@telefonica.com>
diff --git a/installers/install_from_source.sh b/installers/install_osm.sh
similarity index 83%
rename from installers/install_from_source.sh
rename to installers/install_osm.sh
index 9696671..f24f938 100755
--- a/installers/install_from_source.sh
+++ b/installers/install_osm.sh
@@ -15,13 +15,14 @@
 
 function usage(){
     echo -e "usage: $0 [OPTIONS]"
-    echo -e "Install OSM from source code"
+    echo -e "Install OSM from binaries or source code (by default, from binaries)"
     echo -e "  OPTIONS"
     echo -e "     --uninstall:   uninstall OSM: remove the containers and delete NAT rules"
-    echo -e "     -b <branch>:   install OSM from source code using a specific branch (master, v1.0, ...) or tag"
-    echo -e "                    -b master"
-    echo -e "                    -b v1.0"
-    echo -e "                    -b tags/v1.1.0"
+    echo -e "     --source:      install OSM from source code using the latest stable tag"
+    echo -e "     -b <refspec>:  install OSM from source code using a specific branch (master, v2.0, ...) or tag"
+    echo -e "                    -b master          (main dev branch)"
+    echo -e "                    -b v2.0            (v2.0 branch)"
+    echo -e "                    -b tags/v1.1.0     (a specific tag)"
     echo -e "                    ..."
     echo -e "     --develop:     (deprecated, use '-b master') install OSM from source code using the master branch"
     echo -e "     --nat:         install only NAT rules"
@@ -33,6 +34,7 @@
 
 #Uninstall OSM: remove containers
 function uninstall(){
+    echo -e "\nUninstalling OSM"
     if [ $RC_CLONE ] || [ -n "$TEST_INSTALLER" ]; then
         $OSM_DEVOPS/jenkins/host/clean_container RO
         $OSM_DEVOPS/jenkins/host/clean_container VCA
@@ -85,13 +87,13 @@
         echo "         Nothing to be done."
     else
         echo "         Update required."
-        lxc exec $CONTAINER -- service openmano stop
+        lxc exec $CONTAINER -- service osm-ro stop
         lxc exec $CONTAINER -- git -C /opt/openmano stash
         lxc exec $CONTAINER -- git -C /opt/openmano pull --rebase
         lxc exec $CONTAINER -- git -C /opt/openmano checkout $CHECKOUT_ID
         lxc exec $CONTAINER -- git -C /opt/openmano stash pop
         lxc exec $CONTAINER -- /opt/openmano/database_utils/migrate_mano_db.sh
-        lxc exec $CONTAINER -- service openmano start
+        lxc exec $CONTAINER -- service osm-ro start
     fi
     echo
 
@@ -137,8 +139,8 @@
     . $OSM_DEVOPS/installers/export_ips
 
     echo -e "       Configuring RO"
-    lxc exec RO -- sed -i -e "s/^\#\?log_socket_host:.*/log_socket_host: $SO_CONTAINER_IP/g" /opt/openmano/openmanod.cfg
-    lxc exec RO -- service openmano restart
+    lxc exec RO -- sed -i -e "s/^\#\?log_socket_host:.*/log_socket_host: $SO_CONTAINER_IP/g" /etc/osm/openmanod.cfg
+    lxc exec RO -- service osm-ro restart
     time=0; step=2; timelength=20; while [ $time -le $timelength ]; do sleep $step; echo -n "."; time=$((time+step)); done; echo
     lxc exec RO -- openmano tenant-delete -f osm >/dev/null
     RO_TENANT_ID=`lxc exec RO -- openmano tenant-create osm |awk '{print $1}'`
@@ -192,6 +194,7 @@
 SHOWOPTS=""
 COMMIT_ID=""
 ASSUME_YES=""
+INSTALL_FROM_SOURCE=""
 
 while getopts ":hy-:b:" o; do
     case "${o}" in
@@ -203,6 +206,7 @@
             ;;
         -)
             [ "${OPTARG}" == "help" ] && usage && exit 0
+            [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && continue
             [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
             [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
             [ "${OPTARG}" == "nat" ] && NAT="y" && continue
@@ -229,6 +233,7 @@
 
 if [ -n "$SHOWOPTS" ]; then
     echo "DEVELOP=$DEVELOP"
+    echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
     echo "UNINSTALL=$UNINSTALL"
     echo "NAT=$NAT"
     echo "UPDATE=$UPDATE"
@@ -241,7 +246,7 @@
 fi
 
 [ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
-[ -n "$TEST_INSTALLER" ] && [ -z "$COMMIT_ID" ]  && echo "Use -b option to specify the branch to use for the test (e.g.: v1.0)" && exit 0
+[ -n "$COMMIT_ID" ] && INSTALL_FROM_SOURCE="y"
 
 if [ -n "$TEST_INSTALLER" ]; then
     echo -e "\nUsing local devops repo for OSM installation"
@@ -253,7 +258,7 @@
 fi
 
 echo -e "Checking required packages: git"
-dpkg -l git &>/dev/null || ! echo -e "     git not installed.\nInstalling git requires root privileges" || sudo apt install -y git
+dpkg -l git &>/dev/null || ! echo -e "     git not installed.\nInstalling git requires root privileges" || sudo apt-get install -y git
 if [ -z "$TEST_INSTALLER" ]; then
     echo -e "\nCloning devops repo temporarily"
     git clone https://osm.etsi.org/gerrit/osm/devops.git $TEMPDIR
@@ -265,8 +270,7 @@
 [ -z "$COMMIT_ID" ] && [ -z "$LATEST_STABLE_DEVOPS" ] && echo "Could not find the current latest stable release" && exit 0
 echo "Latest tag in devops repo: $LATEST_STABLE_DEVOPS"
 [ -z "$COMMIT_ID" ] && [ -n "$LATEST_STABLE_DEVOPS" ] && COMMIT_ID="tags/$LATEST_STABLE_DEVOPS"
-[ -z "$TEST_INSTALLER" ] && git -C $TEMPDIR checkout $LATEST_STABLE_DEVOPS
-echo -e "\n Installing OSM from refspec: $COMMIT_ID"
+[ -z "$TEST_INSTALLER" ] && git -C $TEMPDIR checkout tags/$LATEST_STABLE_DEVOPS
 
 OSM_DEVOPS=$TEMPDIR
 OSM_JENKINS="$TEMPDIR/jenkins"
@@ -278,27 +282,35 @@
 [ -n "$RECONFIGURE" ] && configure && echo -e "\nDONE" && exit 0
 
 #Installation starts here
-if [ -z "$ASSUME_YES" ]; then 
+echo -e "\nInstalling OSM from refspec: $COMMIT_ID"
+if [ -n "$INSTALL_FROM_SOURCE" ] && [ -z "$ASSUME_YES" ]; then 
     read -e -p "The installation will take about 75-90 minutes. Continue (Y/n)?" USER_CONFIRMATION
     [ -n "$USER_CONFIRMATION" ] && [ "$USER_CONFIRMATION" != "yes" ] && \
         [ "$USER_CONFIRMATION" != "y" ] && echo "Cancelled!" && exit 0
 fi
 
+echo -e "\nChecking required packages: wget, curl, tar"
+dpkg -l wget curl tar &>/dev/null || ! echo -e "    One or several packages are not installed.\nInstalling required packages\n     Root privileges are required" || sudo apt-get install -y wget curl tar
+
 echo -e "Checking required packages: lxd"
 lxd --version &>/dev/null || FATAL "lxd not present, exiting."
-
-wget -q -O- https://osm-download.etsi.org/ftp/osm-1.0-one/README.txt &> /dev/null
-
 [ -n "$LXD" ] && echo -e "\nConfiguring lxd" && install_lxd
 
-echo -e "\nChecking required packages: wget, curl, tar"
-dpkg -l wget curl tar &>/dev/null || ! echo -e "    One or several packages are not installed.\nInstalling required packages\n     Root privileges are required" || sudo apt install -y wget curl tar
+wget -q -O- https://osm-download.etsi.org/ftp/osm-2.0-two/README.txt &> /dev/null
 
-echo -e "\nCreating the containers and building ..."
-$OSM_DEVOPS/jenkins/host/start_build RO --notest checkout $COMMIT_ID || FATAL "RO container build failed (refspec: '$COMMIT_ID')"
-$OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA container build failed"
-$OSM_DEVOPS/jenkins/host/start_build SO checkout $COMMIT_ID || FATAL "SO container build failed (refspec: '$COMMIT_ID')"
-$OSM_DEVOPS/jenkins/host/start_build UI checkout $COMMIT_ID || FATAL "UI container build failed (refspec: '$COMMIT_ID')"
+if [ -z "$INSTALL_FROM_SOURCE" ]; then
+    echo -e "\nCreating the containers and installing from binaries ..."
+    $OSM_DEVOPS/jenkins/host/install RO || FATAL "RO install failed"
+    $OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA install failed"
+    $OSM_DEVOPS/jenkins/host/install SO || FATAL "SO install failed"
+    $OSM_DEVOPS/jenkins/host/install UI || FATAL "UI install failed"
+else #install from source
+    echo -e "\nCreating the containers and building from source ..."
+    $OSM_DEVOPS/jenkins/host/start_build RO --notest checkout $COMMIT_ID || FATAL "RO container build failed (refspec: '$COMMIT_ID')"
+    $OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA container build failed"
+    $OSM_DEVOPS/jenkins/host/start_build SO checkout $COMMIT_ID || FATAL "SO container build failed (refspec: '$COMMIT_ID')"
+    $OSM_DEVOPS/jenkins/host/start_build UI checkout $COMMIT_ID || FATAL "UI container build failed (refspec: '$COMMIT_ID')"
+fi
 
 #Install iptables-persistent and configure NAT rules
 nat
@@ -306,5 +318,5 @@
 #Configure components
 configure
 
-wget -q -O- https://osm-download.etsi.org/ftp/osm-1.0-one/README2.txt &> /dev/null
+wget -q -O- https://osm-download.etsi.org/ftp/osm-2.0-two/README2.txt &> /dev/null
 echo -e "\nDONE"
diff --git a/jenkins/RO/install b/jenkins/RO/install
new file mode 100755
index 0000000..2f6be01
--- /dev/null
+++ b/jenkins/RO/install
@@ -0,0 +1,69 @@
+#!/bin/bash
+#
+#   Copyright 2016 Telefónica Investigación y Desarrollo, S.A.U.
+#
+#   Licensed under the Apache License, Version 2.0 (the "License");
+#   you may not use this file except in compliance with the License.
+#   You may obtain a copy of the License at
+#
+#       http://www.apache.org/licenses/LICENSE-2.0
+#
+#   Unless required by applicable law or agreed to in writing, software
+#   distributed under the License is distributed on an "AS IS" BASIS,
+#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+#   See the License for the specific language governing permissions and
+#   limitations under the License.
+# 
+# Authors:
+#    - Gerardo Garcia - gerardo.garciadeblas@telefonica.com
+# 
+
+HERE=$(realpath $(dirname $0))
+OSM_JENKINS=$(dirname $HERE)
+. $OSM_JENKINS/common/all_funcs
+
+# SET YOUR MDG repository name here
+export OSM_MDG=RO
+OSM_load_config
+
+# Installation starts here
+apt-get update
+
+apt-get -y install python-pip
+pip install --upgrade pip
+pip install pyvcloud
+pip install progressbar
+pip install prettytable
+pip install pyvmomi
+
+#Dependencies below will be installed directly from packages and must be removed
+#apt-get -y install libmysqlclient-dev libssl-dev libffi-dev mysql-client
+#apt-get -y install python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils
+#apt-get -y install python-cinderclient python-glanceclient python-keystoneclient python-neutronclient python-novaclient python-mysqldb python-yaml
+#apt-get -y install python-boto
+
+#Release ONE
+curl https://osm-download.etsi.org/repository/osm/debian/ReleaseONE/OSM%20ETSI%20Release%20Key.gpg |apt-key add -
+add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseONE unstable RO openvim"
+#add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseONE stable RO openvim"
+
+#Release TWO
+#curl https://osm-download.etsi.org/repository/osm/debian/ReleaseTWO/OSM%20ETSI%20Release%20Key.gpg |apt-key add -
+#add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseTWO stable RO openvim"
+
+apt-get update
+apt-get -y install python-lib-osm-openvim
+apt-get -y install python-osm-ro
+
+OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` || FATAL "lib-osm-openvim was not properly installed" 
+OSMRO_PATH=`python -c 'import osm_ro; print osm_ro.__path__[0]'` || FATAL "osm-ro was not properly installed"
+
+${OSMRO_PATH}/database_utils/install-db-server.sh --updatedb || FATAL "osm-ro db installation failed"
+${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -u mano -p manopw -d mano_vim_db --updatedb || FATAL "lib-osm-openvim db installation failed"
+service osm-ro restart
+
+RC=$?
+INFO "done, RC=$RC"
+exit $RC
+
+
diff --git a/jenkins/SO/install b/jenkins/SO/install
new file mode 100755
index 0000000..b45b4cb
--- /dev/null
+++ b/jenkins/SO/install
@@ -0,0 +1,87 @@
+#!/bin/bash
+#   Copyright 2016 RIFT.IO Inc
+#
+#   Licensed under the Apache License, Version 2.0 (the "License");
+#   you may not use this file except in compliance with the License.
+#   You may obtain a copy of the License at
+#
+#       http://www.apache.org/licenses/LICENSE-2.0
+#
+#   Unless required by applicable law or agreed to in writing, software
+#   distributed under the License is distributed on an "AS IS" BASIS,
+#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+#   See the License for the specific language governing permissions and
+#   limitations under the License.
+# 
+# TEMPLATE script to start a build. This is run inside a container
+#
+# 6 July 2016 -- Jeremy.Mordkoff@riftio.com -- adapted from the riftware version
+# 
+
+HERE=$(realpath $(dirname $0))
+OSM_JENKINS=$(dirname $HERE)
+. $OSM_JENKINS/common/all_funcs
+
+# SET YOU MDG repository name here
+export OSM_MDG=SO
+OSM_load_config
+
+#OSM_git_checkout "$@"
+
+#trap 'WARNING "INTERRUPT"; exit 1' INT
+
+#./BUILD.sh -s
+
+INFO "starting install $MDG"
+
+#curl http://repos.riftio.com/public/xenial-riftware-public-key | sudo apt-key add -
+#curl -o /etc/apt/sources.list.d/RIFT.list http://buildtracker.riftio.com/repo_file/ub16/OSM/
+#apt-get update
+#apt-get install -y libxml2-dev libxslt-dev
+#/usr/rift/container_tools/mkcontainer --modes build --modes ext --repo OSM
+#pip3 install lxml==3.4.0
+
+#Release ONE
+curl https://osm-download.etsi.org/repository/osm/debian/ReleaseONE/OSM%20ETSI%20Release%20Key.gpg |apt-key add -
+add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseONE unstable SO UI RO openvim"
+#add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseONE stable SO UI RO openvim"
+
+#Release TWO
+#curl https://osm-download.etsi.org/repository/osm/debian/ReleaseTWO/OSM%20ETSI%20Release%20Key.gpg |apt-key add -
+#add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseTWO stable SO UI RO openvim"
+
+apt-get update
+apt-get install -y \
+    rw.core.mano-rwcal_yang_ylib-1.0 \
+    rw.core.mano-rwconfig_agent_yang_ylib-1.0 \
+    rw.core.mano-rwlaunchpad_yang_ylib-1.0 \
+    rw.core.mano-mano_yang_ylib-1.0 \
+    rw.core.mano-common-1.0 \
+    rw.core.mano-rwsdn_yang_ylib-1.0 \
+    rw.core.mano-rwsdnal_yang_ylib-1.0 \
+    rw.core.mano-rwsdn-1.0 \
+    rw.core.mano-mano-types_yang_ylib-1.0 \
+    rw.core.mano-rwcal-cloudsim-1.0 \
+    rw.core.mano-rwcal-1.0 \
+    rw.core.mano-rw_conman_yang_ylib-1.0 \
+    rw.core.mano-rwcalproxytasklet-1.0 \
+    rw.core.mano-rwlaunchpad-1.0 \
+    rw.core.mano-rwcal-openmano-vimconnector-1.0 \
+    rw.core.mano-rwcal-propcloud1-1.0 \
+    rw.core.mano-lpmocklet_yang_ylib-1.0 \
+    rw.core.mano-rwmon-1.0 \
+    rw.core.mano-rwcloud_yang_ylib-1.0 \
+    rw.core.mano-rwcal-openstack-1.0 \
+    rw.core.mano-rw.core.mano_foss \
+    rw.core.mano-rwmon_yang_ylib-1.0 \
+    rw.core.mano-rwcm-1.0 \
+    rw.core.mano-rwcal-mock-1.0 \
+    rw.core.mano-rwcal-cloudsimproxy-1.0 \
+    rw.core.mano-models-1.0 \
+    rw.core.mano-rwcal-aws-1.0
+
+RC=$?
+
+INFO "done, RC=$RC"
+exit $RC
+
diff --git a/jenkins/UI/install b/jenkins/UI/install
new file mode 100755
index 0000000..2a3b9b6
--- /dev/null
+++ b/jenkins/UI/install
@@ -0,0 +1,62 @@
+#!/bin/bash
+#   Copyright 2016 RIFT.IO Inc
+#
+#   Licensed under the Apache License, Version 2.0 (the "License");
+#   you may not use this file except in compliance with the License.
+#   You may obtain a copy of the License at
+#
+#       http://www.apache.org/licenses/LICENSE-2.0
+#
+#   Unless required by applicable law or agreed to in writing, software
+#   distributed under the License is distributed on an "AS IS" BASIS,
+#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+#   See the License for the specific language governing permissions and
+#   limitations under the License.
+# 
+# TEMPLATE script to start a build. This is run inside a container
+#
+# 6 July 2016 -- Jeremy.Mordkoff@riftio.com -- adapted from the riftware version
+# 
+
+HERE=$(realpath $(dirname $0))
+OSM_JENKINS=$(dirname $HERE)
+. $OSM_JENKINS/common/all_funcs
+
+# SET YOU MDG repository name here
+export OSM_MDG=UI
+OSM_load_config
+
+#OSM_git_checkout "$@"
+
+#trap 'WARNING "INTERRUPT"; exit 1' INT
+
+#./BUILD.sh -u
+
+INFO "starting install $MDG"
+
+#Release ONE
+curl https://osm-download.etsi.org/repository/osm/debian/ReleaseONE/OSM%20ETSI%20Release%20Key.gpg |apt-key add -
+add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseONE unstable SO UI RO openvim"
+#add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseONE stable SO UI RO openvim"
+
+#Release TWO
+#curl https://osm-download.etsi.org/repository/osm/debian/ReleaseTWO/OSM%20ETSI%20Release%20Key.gpg |apt-key add -
+#add-apt-repository -y "deb https://osm-download.etsi.org/repository/osm/debian/ReleaseTWO stable SO UI RO openvim"
+
+apt-get update
+apt-get install -y \
+    rw.ui-about \
+    rw.ui-logging \
+    rw.ui-skyquake \
+    rw.ui-accounts \
+    rw.ui-composer \
+    rw.ui-launchpad \
+    rw.ui-debug \
+    rw.ui-config \
+    rw.ui-dummy_component
+
+RC=$?
+
+INFO "done, RC=$RC"
+exit $RC
+
diff --git a/jenkins/host/install b/jenkins/host/install
new file mode 100755
index 0000000..ade30fb
--- /dev/null
+++ b/jenkins/host/install
@@ -0,0 +1,52 @@
+#!/bin/bash
+#
+#   Licensed under the Apache License, Version 2.0 (the "License");
+#   you may not use this file except in compliance with the License.
+#   You may obtain a copy of the License at
+#
+#       http://www.apache.org/licenses/LICENSE-2.0
+#
+#   Unless required by applicable law or agreed to in writing, software
+#   distributed under the License is distributed on an "AS IS" BASIS,
+#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+#   See the License for the specific language governing permissions and
+#   limitations under the License.
+#
+# install is run on a host to install a MDG from binaries
+#
+
+
+HERE=$(realpath $(dirname $0))
+OSM_JENKINS=$(dirname $HERE)
+. $OSM_JENKINS/common/all_funcs
+
+[ $# -lt 1 ] && FATAL "arg is MDG name"
+
+export OSM_MDG=$1
+shift
+OSM_load_config
+
+if ! container_exists $OSM_BUILD_CONTAINER; then
+	CONTAINER_OPTS=""
+	[[ "$OSM_BUILD_CONTAINER_PRIVILEGED" == yes ]] && CONTAINER_OPTS="$CONTAINER_OPTS -c security.privileged=true"
+	[[ "$OSM_BUILD_CONTAINER_ALLOW_NESTED" == yes ]] && CONTAINER_OPTS="$CONTAINER_OPTS -c security.nesting=true"
+	create_container $OSM_BASE_IMAGE $OSM_BUILD_CONTAINER $CONTAINER_OPTS
+	wait_container_up $OSM_BUILD_CONTAINER
+	if [ ${OSM_USE_LOCAL_DEVOPS:-false} ]; then
+		container_push_devops $OSM_BUILD_CONTAINER
+	else
+		container_exec $OSM_BUILD_CONTAINER git clone ${OSM_GIT_URL}/devops
+	fi
+else
+	if [ ${OSM_USE_LOCAL_DEVOPS:-false} ]; then
+		container_push_devops $OSM_BUILD_CONTAINER
+	else
+		container_exec $OSM_BUILD_CONTAINER git -C devops pull
+	fi
+fi
+
+container_exec $OSM_BUILD_CONTAINER ./devops/jenkins/$OSM_MDG/install $*
+RC=$?
+INFO "$OSM_MDG install complete. Return code was $RC"
+exit $RC
+